/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.empresa.intranet.modelo.incidencias;

import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.tipos.Tipo;
import java.io.Serializable;
import java.util.Date;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Temporal;

/**
 *
 * @author Ibecerra
 */

//Para indicar que es una entindad persistente
@Entity
//Imprescindible crear un constructor serializable vacío para trabajar con hibernate
public class Incidencia implements Serializable {
    
    private Long id;
    private int numero;
    private Tienda tienda;
    private Date fechaalta;
    private String detectadapor;
    private int recepcionada;
    private String numeroalbaran;
    private int numerolinea;
    private String descripcion;
    private Origen origen;
    private Tipo tipo;
    
    
//Imprescindible crear un constructor vacío para trabajar con hibernate
    public Incidencia() {
    }
    
    public Incidencia(int numero, Tienda tienda, Date fechaalta, String detectadapor, int recepcionada, String numeroalbaran, int numerolinea, String descripcion, Origen origen, Tipo tipo) {
        this.numero = numero;
        this.tienda = tienda;
        this.fechaalta = fechaalta;
        this.detectadapor = detectadapor;
        this.recepcionada = recepcionada;
        this.numeroalbaran = numeroalbaran;
        this.numerolinea = numerolinea;
        this.descripcion = descripcion;
        this.origen = origen;
        this.tipo = tipo;
    }

   @Id
   @GeneratedValue(strategy = GenerationType.AUTO)
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public int getNumero() {
        return numero;
    }

    public void setNumero(int numero) {
        this.numero = numero;
    }
    
    @Temporal(javax.persistence.TemporalType.DATE)
    public Date getFechaalta() {
        return fechaalta;
    }

    @ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="idTienda")

    public Tienda getTienda() {
        return tienda;
    }

    public void setTienda(Tienda tienda) {
        this.tienda = tienda;
    }

    public void setFechaalta(Date fechaalta) {
        this.fechaalta = fechaalta;
    }

    public String getDetectadapor() {
        return detectadapor;
    }

    public void setDetectadapor(String detectadapor) {
        this.detectadapor = detectadapor;
    }

    public int getRecepcionada() {
        return recepcionada;
    }

    public void setRecepcionada(int recepcionada) {
        this.recepcionada = recepcionada;
    }

    public String getNumeroalbaran() {
        return numeroalbaran;
    }

    public void setNumeroalbaran(String numeroalbaran) {
        this.numeroalbaran = numeroalbaran;
    }

    public int getNumerolinea() {
        return numerolinea;
    }

    public void setNumerolinea(int numerolinea) {
        this.numerolinea = numerolinea;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }
    
  
    @ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="idOrigen")  
    public Origen getOrigen() {
        return origen;
    }

    public void setOrigen(Origen origen) {
        this.origen = origen;
    }

        @ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="idTipo")  
    public Tipo getTipo() {
        return tipo;
    }

    public void setTipo(Tipo tipo) {
        this.tipo = tipo;
    }


}

