package com.empresa.intranet.modelo.lineaspedidos;

import com.empresa.intranet.modelo.util.GenericDaoHibernate;
import java.util.List;
import org.springframework.stereotype.Repository;


@Repository("lineaPedidoDao")
public class LineaPedidoDaoHibernate extends
		GenericDaoHibernate<LineaPedido, Long> implements LineaPedidoDao {
    @Override
     public List<LineaPedido> listaLineasPedidos(Long idPedido) {
        return getSession().createQuery(
	        	"SELECT p FROM LineaPedido p WHERE p.pedido.id = :id ORDER BY p.id asc")
	           	.setParameter("id", idPedido).list();
    }
    
    @Override
    public int numeroLineasPedidos(Long idPedido) {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(p) FROM LineaPedido p WHERE p.pedido.id = :id")
        .setParameter("id", idPedido).uniqueResult();	
        return (int) n;
    }
}