/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.empresa.intranet.modelo.pedidos;

import com.empresa.intranet.modelo.tiendas.Tienda;
import java.io.Serializable;
import java.util.Date;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Temporal;

/**
 *
 * @author Ibecerra
 */

//Para indicar que es una entindad persistente
@Entity
//Imprescindible crear un constructor serializable vacío para trabajar con hibernate
public class Pedido implements Serializable {
    private Long id;
    private int numero;
    private Tienda tienda;
    private Date fechaalta;
    private int recepcionado;
    
//Imprescindible crear un constructor vacío para trabajar con hibernate
    public Pedido() {
    }

    public Pedido(int numero, Tienda tienda, Date fechaalta, int recepcionado) {
        this.numero = numero;
        this.tienda = tienda;
        this.fechaalta = fechaalta;
        this.recepcionado = recepcionado;
    }
    
// Con esta secuenia le decimos a hibernate que 
// auto incrementamos el campo que esta en el get
      
   @Id
   @GeneratedValue(strategy = GenerationType.AUTO)
    
    public Long getId() {
        return id;
    }   

    public void setId(Long id) {
        this.id = id;
    }

    public int getNumero() {
        return numero;
    }

    public void setNumero(int numero) {
        this.numero = numero;
    }
    
    @ManyToOne(fetch=FetchType.LAZY)
    @JoinColumn(name="idTienda")

    public Tienda getTienda() {
        return tienda;
    }

    public void setTienda(Tienda tienda) {
        this.tienda = tienda;
    }
    
    @Temporal(javax.persistence.TemporalType.DATE)
    public Date getFechaalta() {
        return fechaalta;
    }

    public void setFechaalta(Date fechaalta) {
        this.fechaalta = fechaalta;
    }

    public int getRecepcionado() {
        return recepcionado;
    }

    public void setRecepcionado(int recepcionado) {
        this.recepcionado = recepcionado;
    }




   

}

