package com.empresa.intranet.modelo.pedidos;

import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuarioDao;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.util.GenericDaoHibernate;
import java.util.List;
import javax.management.InstanceNotFoundException;
import org.hibernate.Query;
import org.springframework.stereotype.Repository;

@Repository("pedidoDao")
public class PedidoDaoHibernate extends
		GenericDaoHibernate<Pedido, Long> implements PedidoDao {

//    @Override
//    public List<Pedido> buscarporTienda(Tienda tienda) throws InstanceNotFoundException {
//            List<Pedido> incidencias = getSession().createQuery(
//                            "SELECT u FROM Incidencia u WHERE u.idTienda = :id")
//                            .setParameter("id", tienda.getId()).list();
//
//            if (incidencias == null || incidencias.isEmpty()) {
//                            throw new InstanceNotFoundException("No se han encontrado incidencias de la tienda "+tienda.getNombre());
//            } else {
//                    return incidencias;
//            }



//            }  
    private PerfilUsuarioDao usuarioDao;
    
    @Override
    public List<Pedido> listaPedidos(int startIndex, int count) {
        return getSession().createQuery(
	        	"SELECT p FROM Pedido p " +
	        	"ORDER BY p.id asc").
	           	setFirstResult(startIndex).
	           	setMaxResults(count).list();    
    }
    
    @Override
    public List<Pedido> listaPedidos(int startIndex, int count,Long idTienda) throws InstanceNotFoundException{
        List<Pedido> pedidos = getSession().createQuery(
	        	"SELECT p FROM Pedido p where p.tienda.id=:id order by p.id asc")
                        .setParameter("id",idTienda).setFirstResult(startIndex).
	           	setMaxResults(count).list();
        
            if (pedidos == null || pedidos.isEmpty()) {
                            throw new InstanceNotFoundException("No se han encontrado pedidos de la tienda ");
            } else {
                    return pedidos;
            }        
    }    
    
  
    
    @Override
    public int numeroPedidos() {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(p) FROM Pedido p").
        uniqueResult();	
        return (int) n;
           
    } 
    
    @Override
    public int numeroPedidos(Long idTienda) {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(p) FROM Pedido p WHERE p.tienda.id = :id")
        .setParameter("id", idTienda)
        .uniqueResult();	
        return (int) n;
    } 
    
    @Override
    public void eliminaLineasPedido(Long idPedido) {
        int n = getSession().createQuery(
        "DELETE FROM LineaPedido WHERE idpedido = :id")
        .setParameter("id", idPedido)
        .executeUpdate();       
    }     

}