package com.empresa.intranet.modelo.perfilusuario;

import com.empresa.intranet.modelo.roles.Rol;
import com.empresa.intranet.modelo.tiendas.Tienda;
import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;

@Entity
public class PerfilUsuario implements Serializable {

	private Long perfilUsuarioId;
	private String loginName;
	private String encryptedPassword;
	private String firstName;
	private String lastName;
	private String email;
        private Rol rol;
        private Tienda tienda;



	public PerfilUsuario() {
	}

	public PerfilUsuario(String loginName, String encryptedPassword,
			String firstName, String lastName, String email, Rol rol,Tienda tienda) {

		/**
		 * NOTE: "perfilUsuarioId" *must* be left as "null" since its value is
		 * automatically generated.
		 */

		this.loginName = loginName;
		this.encryptedPassword = encryptedPassword;
		this.firstName = firstName;
		this.lastName = lastName;
		this.email = email;
                this.rol = rol;
                this.tienda = tienda;
	}

	@Column(name = "usrId")
	@SequenceGenerator( // It only takes effect for
	name = "PerfilUsuarioIdGenerator", // databases providing identifier
	sequenceName = "PerfilUsuarioSeq")
	// generators.
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO, generator = "PerfilUsuarioIdGenerator")
	public Long getPerfilUsuarioId() {
		return perfilUsuarioId;
	}

	public void setPerfilUsuarioId(Long perfilUsuarioId) {
		this.perfilUsuarioId = perfilUsuarioId;
	}

	public String getLoginName() {
		return loginName;
	}

	public void setLoginName(String loginName) {
		this.loginName = loginName;
	}

	@Column(name = "enPassword")
	public String getEncryptedPassword() {
		return encryptedPassword;
	}

	public void setEncryptedPassword(String encryptedPassword) {
		this.encryptedPassword = encryptedPassword;
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

        @ManyToOne(fetch=FetchType.LAZY)
        @JoinColumn(name="idTienda")
        
        public Tienda getTienda() {
            return tienda;
        }

        public void setTienda(Tienda tienda) {
            this.tienda = tienda;
        }


        @ManyToOne(fetch=FetchType.LAZY)
        @JoinColumn(name="idRol")
        
    public Rol getRol() {
        return rol;
    }

    public void setRol(Rol rol) {
        this.rol = rol;
    }
	
}
