package com.empresa.intranet.modelo.perfilusuario;

import com.empresa.intranet.modelo.util.GenericDaoHibernate;
import java.util.List;
import javax.management.InstanceNotFoundException;
import org.springframework.stereotype.Repository;

@Repository("perfilUsuarioDao")
public class PerfilUsuarioDaoHibernate extends
		GenericDaoHibernate<PerfilUsuario, Long> implements PerfilUsuarioDao {

    @Override
	public PerfilUsuario findByLoginName(String loginName) throws InstanceNotFoundException {

    	PerfilUsuario perfilUsuario = (PerfilUsuario) getSession().createQuery(
    			"SELECT u FROM PerfilUsuario u WHERE u.loginName = :loginName")
    			.setParameter("loginName", loginName)
    			.uniqueResult();
    	if (perfilUsuario == null) {
   			throw new InstanceNotFoundException(loginName + " - " + PerfilUsuario.class.getName());
    	} else {
    		return perfilUsuario;
    	}
    	
	}
        
    @Override
    public int numeroPerfiles() {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(p) FROM PerfilUsuario p").
        uniqueResult();	
        return (int) n;
    }          
    
    @Override
    public List<PerfilUsuario> listaPerfiles(int startIndex, int count) {
        return getSession().createQuery(
	        	"SELECT p FROM PerfilUsuario p " +
	        	"ORDER BY p.id asc").
	           	setFirstResult(startIndex).
	           	setMaxResults(count).list();
    }    

}