package com.empresa.intranet.modelo.serviciotienda;

import com.empresa.intranet.modelo.incidencias.Incidencia;
import com.empresa.intranet.modelo.lineaspedidos.LineaPedido;
import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.tipos.Tipo;
import com.empresa.intranet.modelo.serviciousuario.*;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.util.DuplicatedInstanceException;
import java.util.Date;
import java.util.List;
import javax.management.InstanceNotFoundException;


public interface ServicioTienda  {

    public Tienda crearTienda(Tienda tienda); 
    public void eliminarTienda(Tienda tienda);
    public void modificarTienda(Tienda tienda);
    public Tienda buscarTienda(String nombre);
    public Incidencia crearIncidencia(Incidencia incidencia);
    public void eliminarIncidencia(Incidencia incidencia);
    public void modificarIncidencia(Incidencia incidencia);   
    public List<Incidencia> buscarporTienda(Tienda tienda) throws InstanceNotFoundException;
    public List<Incidencia> buscarporfecha(Date fecha) throws InstanceNotFoundException;
    public List<Incidencia> buscarpordescripcion(String descripcion) throws InstanceNotFoundException;
    public List<Incidencia> listaIncidencias(int startIndex, int count);
    public List<Incidencia> listaIncidencias(int startIndex, int count, Long idTienda) throws InstanceNotFoundException;
    public Origen crearOrigen(Origen origen);
    public void eliminarOrigen(Origen origen);
    public void modificarOrigen(Origen origen);  
    public Tipo leerTipo(Long id);
    public Tipo crearTipo(Tipo tipo);
    public void eliminarTipo(Tipo tipo);
    public void modificarTipo(Tipo tipo);   
    public Pedido crearPedido(Pedido pedido);
    public void eliminarPedido(Pedido pedido);
    public void modificarPedido(Pedido pedido);    
    public LineaPedido crearLineaPedido(LineaPedido lineapedido);
    public void eliminarLineaPedido(LineaPedido lineapedido);
    public void modificarLineaPedido(LineaPedido lineapedido);  
    public int numeroLineasPedidos(Long idPedido);
    public List<LineaPedido> listaLineasPedidos(Long idPedido);
    
    public int numeroTiendas();
    public List<Tienda> listaTiendas(int startIndex, int count);
    public int numeroTipos();
    public List<Tipo> listaTipos(int startIndex, int count);    
    public int numeroOrigenes();    
    public List<Origen> listaOrigenes(int startIndex, int count);   
    public Tienda leerTienda(Long id);
    public Origen leerOrigen(Long id);
    public int numeroIncidencias();
    public int numeroIncidencias(Long idTienda);
    public Incidencia leerIncidencia(Long id);
    public List<Pedido> listaPedidos(int startIndex, int count);
    public List<Pedido> listaPedidos(int startIndex, int count,Long idTienda)throws InstanceNotFoundException;
    public Pedido leerPedido(Long id);
    public int numeroPedidos();
    public int numeroPedidos(Long idTienda);
   
}
