package com.empresa.intranet.modelo.serviciousuario;
import com.empresa.intranet.modelo.roles.Rol;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.PasswordIncorectaException;
import com.empresa.intranet.modelo.serviciousuario.PerfilUsuarioDetalle;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.util.DuplicatedInstanceException;
import java.util.List;
import javax.management.InstanceNotFoundException;


public interface ServicioUsuario  {

    public Rol registerRol(Rol rol);
     
    public PerfilUsuario registerUser(String loginName, String clearPassword,
            PerfilUsuarioDetalle perfilUsuarioDetails)
            throws DuplicatedInstanceException ;

    public PerfilUsuario login(String loginName, String password,
            boolean passwordIsEncrypted) throws InstanceNotFoundException,
            PasswordIncorectaException;
    
    public PerfilUsuario findPerfilUsuario(Long perfilUsuarioId)
            throws InstanceNotFoundException ;

    public void updatePerfilUsuarioDetails(Long perfilUsuarioId,
            PerfilUsuarioDetalle perfilUsuarioDetails)
            throws InstanceNotFoundException ;

    public void changePassword(Long perfilUsuarioId, String oldClearPassword,
            String newClearPassword) throws PasswordIncorectaException,
            InstanceNotFoundException ;
    
    public Rol getRol(Long rolId);
    public int numeroPerfiles();
    public List<PerfilUsuario> listaPerfiles(int startIndex, int count);
    
    public void eliminarPerfilUsuario(Long perfilUsuarioId);
    public Tienda getTienda(Long tiendaId);
    public Tienda registerTienda(Tienda tienda);
    public PerfilUsuario leerUsuario(Long id);
    
}
