package com.empresa.intranet.modelo.tiendas;

import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.util.GenericDaoHibernate;
import java.util.List;
import javax.management.InstanceNotFoundException;
import org.springframework.stereotype.Repository;


@Repository("tiendaDao")
public class TiendaDaoHibernate extends
		GenericDaoHibernate<Tienda, Long> implements TiendaDao {
    
        @Override
	public Tienda buscartienda(String nombre) throws InstanceNotFoundException {

    	Tienda tienda = (Tienda) getSession().createQuery(
    			"SELECT u FROM tienda u WHERE u.nombre = :nombre")
    			.setParameter("nombre", nombre)
    			.uniqueResult();
    	if (tienda == null) {
   			throw new InstanceNotFoundException(nombre + " - " + PerfilUsuario.class.getName());
    	} else {
    		return tienda;
    	}
    	
	}    

    @Override
    public int numeroTiendas() {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(t) FROM Tienda t").
        uniqueResult();	
        return (int) n;
    }

    @Override
    public List<Tienda> listaTiendas(int startIndex, int count) {
        return getSession().createQuery(
	        	"SELECT t FROM Tienda t " +
	        	"ORDER BY t.id asc").
	           	setFirstResult(startIndex).
	           	setMaxResults(count).list();
    }

        
}