package com.empresa.intranet.modelo.tipos;

import com.empresa.intranet.modelo.util.GenericDaoHibernate;
import java.util.List;
import org.springframework.stereotype.Repository;


@Repository("tipoDao")
public class TipoDaoHibernate extends
		GenericDaoHibernate<Tipo, Long> implements TipoDao {
    @Override
    public int numeroTipos() {
        long n = (Long) getSession().createQuery(
        "SELECT COUNT(t) FROM Tipo t").
        uniqueResult();	
        return (int) n;
    }

    @Override
    public List<Tipo> listaTipos(int startIndex, int count) {
        return getSession().createQuery(
	        	"SELECT t FROM Tipo t " +
	        	"ORDER BY t.id asc").
	           	setFirstResult(startIndex).
	           	setMaxResults(count).list();
    }    

}