/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.empresa.intranet.modelo.util;

import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import javax.annotation.Resource;
import org.hibernate.Session;
import org.hibernate.SessionFactory;

/**
 *
 * @author ibecerra
 */
public class GenericDaoHibernate <T, PK extends Serializable> implements GenericDao<T, PK> {    
    private Class<T> type = extractEntityClassFromHierarchy();
    @Resource(name = "sessionFactory")
    private SessionFactory sessionFactory;  
   
    @Override
    public PK create(T o) {
        return (PK) getSession().save(o);
    }

    @Override
    public T read(PK id){      
        return (T) getSession().get(type, id);
    }

    @Override
    public void update(T o) {
        getSession().update(o);
    }

    @Override
    public void delete(T o) {
        getSession().delete(o);
    }

    protected Session getSession() {
        return sessionFactory.getCurrentSession();
    }
    
    private Class<T> extractEntityClassFromHierarchy() {
        final Type genericSuperclass = getClass().getGenericSuperclass();
        final ParameterizedType parameterizedType = ((ParameterizedType) genericSuperclass);
        return (Class<T>) parameterizedType.getActualTypeArguments()[0];
    }
}
