package com.empresa.intranet.web.components;

import com.empresa.intranet.web.pages.Index;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.CookiesManager;
import com.empresa.intranet.web.util.UserSession;
import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.Cookies;


public class Layout {
    @SuppressWarnings("unused")
    @Property
    @Parameter(required = false, defaultPrefix = "message")
    private String menuExplanation;

    @SuppressWarnings("unused")
    @Property
    @Parameter(required = true, defaultPrefix = "message")
    private String pageTitle;

    @SuppressWarnings("unused")
    @Property
    @SessionState(create=false)
    private UserSession userSession;

    @Inject
    private Cookies cookies;

    @AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
   	Object onActionFromLogout() {
        userSession = null;
        CookiesManager.removeCookies(cookies);
        return Index.class;
	}
}