package com.empresa.intranet.web.pages.tienda;

import com.empresa.intranet.modelo.incidencias.Incidencia;
import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.PerfilUsuarioDetalle;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.tipos.Tipo;
import com.empresa.intranet.modelo.tipos.TipoDao;
import com.empresa.intranet.modelo.util.DuplicatedInstanceException;
import com.empresa.intranet.web.pages.Index;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.UserSession;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.swing.JOptionPane;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.corelib.components.Form;
import org.apache.tapestry5.corelib.components.TextField;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;


//se le indica qué usuarios (todos, sólo autenticados, etc) pueden acceder a la pagina
@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class CrearIncidencia{

    @Property
    //Con eso podemos hacer el mapeo en el tml
    private String numero;
    @Property
    //Con eso podemos hacer el mapeo en el tml
    private Long incidenciaId;     
    @Property
    private String idTienda;    
    //@Property
    private SimpleDateFormat sdf=new java.text.SimpleDateFormat("dd/MM/yyyy");
    private Date fechaalta=new java.util.Date();     
    @Property
    private String detectadapor;    
    @Property
    private int recepcionada;
    @Property
    private String numeroalbaran;
    @Property
    private long numerolinea;    
    @Property
    private String descripcion;
    @Property
    private String idOrigen;
    @Property
    private String idTipo;  
    
    
    private Tipo tipo;
    private Incidencia incidencia;
    private Origen origen;    
    private Tienda tienda;
    

    
    private List<Tipo> listatipos = new ArrayList<Tipo>();
    private List<Origen> listaorigenes = new ArrayList<Origen>();
    private List<Tienda> listatiendas = new ArrayList<Tienda>();
    
    //Recupero los datos de la sesión del usuario
    @SessionState(create=false)
    private UserSession userSession;
   
    
    //Para recuperar la instancia del servicio del modelo
    @Inject
    private ServicioTienda tiendaService;

    //Elementos que hay en la página tml
    @Component
    private Form registrationForm;

    //Campos que hay en la página tml
    @Component(id = "numero")
    private TextField numeroField;
    @Component(id = "idTienda")
    private TextField idTiendaField;    
//    @Component(id = "fechaalta")
//    private TextField fechaaltaField;            
    @Component(id = "detectadapor")
    private TextField detectadaporField;
    @Component(id = "recepcionada")
    private TextField recepcionadaField;
    @Component(id = "numeroalbaran")
    private TextField numeroalbaranField;
    @Component(id = "numerolinea")
    private TextField numerolineaField;
    @Component(id = "descripcion")
    private TextField descripcionField;
    @Component(id = "idOrigen")
    private TextField idOrigenField;
    @Component(id = "idTipo")
    private TextField idTipoField;    
    
    
    
    

    //Librería que muestra los mensajes de error en el formulario
    @Inject
    private Messages messages;
    
    void onActivate(Long incidenciaId) {	
        if(incidenciaId != null) {
            try {
                this.incidenciaId = incidenciaId;
                this.incidencia = tiendaService.leerIncidencia(this.incidenciaId);
                //System.out.println("xxxxxxxxxxxxxx"+this.pedido.getId()+"xxxxxxxxxxxxxxx");                
                this.numero = Integer.toString(this.incidencia.getNumero());
                this.tienda = this.incidencia.getTienda();
                this.idTienda = String.valueOf(this.tienda.getId());
                this.detectadapor = incidencia.getDetectadapor();
                this.recepcionada = incidencia.getRecepcionada();
                this.numeroalbaran = incidencia.getNumeroalbaran();
                this.numerolinea = incidencia.getNumerolinea();
                this.descripcion = incidencia.getDescripcion();
                this.idOrigen = Long.toString(incidencia.getOrigen().getId());
                this.idTipo = Long.toString(incidencia.getTipo().getId());                             
                
                //System.out.println("xxxxxxxxxxxxxx"+tienda.getNombre()+"xxxxxxxxxxxxxxx");                        
                this.idTienda = Long.toString(this.tienda.getId());                  
            } catch (Exception e) {
                 registrationForm.recordError("error-pedido");
            }
        }        
    }
    
   Object onPassivate() {
    return(new Object [] {incidenciaId}); 
}    


    void onValidateForm() {

        //Con esto tapestry comprueba que los datos que se vayan a enviar sean correctos.    
        if (!registrationForm.isValid()) {
            return;
        }
        
            Long idTipoInt = Long.valueOf(idTipo);
            Long idTiendaInt = Long.valueOf(idTienda);
            tipo = tiendaService.leerTipo(idTipoInt);
            tienda = tiendaService.leerTienda(idTiendaInt);
            origen = tiendaService.leerOrigen(idTipoInt);        
        try {
            if (incidenciaId!=null){
                this.incidencia  = tiendaService.leerIncidencia(incidenciaId);             
                this.incidencia.setDescripcion(descripcion);
                this.incidencia.setDetectadapor(detectadapor);
                this.incidencia.setNumero(Integer.parseInt(numero));
                this.incidencia.setNumeroalbaran(numeroalbaran);
                this.incidencia.setNumerolinea((int)(numerolinea));
                this.incidencia.setOrigen(origen);
                this.incidencia.setRecepcionada(recepcionada);
                this.incidencia.setTienda(tienda);
                this.incidencia.setTipo(tipo);    
                tiendaService.modificarIncidencia(incidencia);
            }
            else {
               
                int numeroInt = Integer.parseInt(numero);                
                int numerolineaInt = (int)numerolinea;                
                 //Aplico el formato a la fecha actual
                fechaalta=sdf.parse(sdf.format(fechaalta));

    //            try {
    //                fechaalta=sdf.parse(sdf.format(fechaalta));
    //            } catch (Exception ex) {
    //               JOptionPane.showMessageDialog(null,"No se ha podido aplicar el formato","Error", JOptionPane.ERROR_MESSAGE);
    //            }            

                Incidencia incidencia = new Incidencia(numeroInt,tienda,fechaalta,detectadapor,recepcionada,numeroalbaran,numerolineaInt,descripcion,origen,tipo);
                tiendaService.crearIncidencia(incidencia);
            }
        } catch (Exception e) {
            registrationForm.recordError( messages
                    .get("error-incidencia"));
        }


    }

    Object onSuccess() {
        return Index.class;

    }

}
