package com.empresa.intranet.web.pages.tienda;

import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.PerfilUsuarioDetalle;
import com.empresa.intranet.modelo.tipos.Tipo;
import com.empresa.intranet.modelo.tipos.TipoDao;
import com.empresa.intranet.modelo.util.DuplicatedInstanceException;
import com.empresa.intranet.web.pages.Index;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.UserSession;
import java.util.ArrayList;
import java.util.List;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.corelib.components.Form;
import org.apache.tapestry5.corelib.components.TextField;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;


//se le indica qué usuarios (todos, sólo autenticados, etc) pueden acceder a la pagina
@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class CrearOrigen {
    
    @Property
    //Con eso podemos hacer el mapeo en el tml
    private Long origenId;        

    @Property
    //Con eso podemos hacer el mapeo en el tml
    private String nombre;
    
    private Tipo tipo;
    
    private Origen origen;
    
    @Property
    //Con eso podemos hacer el mapeo en el tml
    private String idTipo;
    
    private List<Tipo> listatipos = new ArrayList<Tipo>();
            
    //Recupero los datos de la sesión del usuario
    @SessionState(create=false)
    private UserSession userSession;

   
    
    //Para recuperar la instancia del servicio del modelo
    @Inject
    private ServicioTienda tiendaService;

    //Elementos que hay en la página tml
    @Component
    private Form registrationForm;

    //Campos que hay en la página tml
    @Component(id = "nombre")
    private TextField nombreField;
    //Campos que hay en la página tml
    @Component(id = "idTipo")
    private TextField idTipoField;    

    //Librería que muestra los mensajes de error en el formulario
    @Inject
    private Messages messages;
    

    void onActivate(Long origenId) {	
        if(origenId != null) {
            try {
                this.origenId = origenId;
                this.origen = tiendaService.leerOrigen(this.origenId);               
                this.idTipo = Long.toString(this.origen.getTipo().getId());
                this.nombre = this.origen.getNombre();                    
            } catch (Exception e) {
                 registrationForm.recordError("error-origen");
            }
        }        
    }
    
   Object onPassivate() {
    return(new Object [] {origenId}); 
}    


    void onValidateForm() {

        //Con esto tapestry comprueba que los datos que se vayan a enviar sean correctos.    
        if (!registrationForm.isValid()) {
            return;
        }
        
       
        try {
                Long idTipoInt = Long.valueOf(idTipo);
                tipo = tiendaService.leerTipo(idTipoInt);            
            if(origenId!=null){
                this.origen = tiendaService.leerOrigen(origenId);                
                this.origen.setNombre(nombre);
                this.origen.setTipo(tipo);
                tiendaService.modificarOrigen(origen);
                
            }
            else{
                Origen origen = new Origen(nombre,tipo);
                tiendaService.crearOrigen(origen);
                }
            
        } catch (Exception e) {
            registrationForm.recordError( messages
                    .get("error-origen"));
        }


    }

    Object onSuccess() {
        return Index.class;

    }

}
