package com.empresa.intranet.web.pages.tienda;

import com.empresa.intranet.modelo.lineaspedidos.LineaPedido;
import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.web.pages.Index;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.LineaPedidoGridDataSource;
import com.empresa.intranet.web.util.UserSession;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.corelib.components.Form;
import org.apache.tapestry5.corelib.components.TextField;
import org.apache.tapestry5.ioc.Messages;
import org.apache.tapestry5.ioc.annotations.Inject;


//se le indica qué usuarios (todos, sólo autenticados, etc) pueden acceder a la pagina
@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class CrearPedido{
    
    @Property
    //Con eso podemos hacer el mapeo en el tml
    private Long pedidoId;    
   

    @Property
    private String numero;
    
    @Property
    private String idTienda;    
    //@Property
    private 
    SimpleDateFormat sdf=new java.text.SimpleDateFormat("dd/MM/yyyy");
    private Date fechaalta=new java.util.Date();      
    @Property
    private int recepcionado;   
    
    private Pedido pedido;
    
    private Tienda tienda; 

    private List<Tienda> listatiendas = new ArrayList<Tienda>();
    
    //Recupero los datos de la sesión del usuario
    @SessionState(create=false)
    private UserSession userSession;
   
    
    //Para recuperar la instancia del servicio del modelo
    @Inject
    private ServicioTienda tiendaService;

    //Elementos que hay en la página tml
    @Component
    private Form registrationForm;

    //Campos que hay en la página tml
    @Component(id = "numero")
    private TextField numeroField;
    @Component(id = "idTienda")
    private TextField idTiendaField;    
//    @Component(id = "fechaalta")
//    private TextField fechaaltaField;            
    @Component(id = "recepcionado")
    private TextField recepcionadoField;

    public Long obtenerPedidoId() {
        return pedidoId;
    }

    public void establecerPedidoId(Long pedidoId) {
        this.pedidoId = pedidoId;
    }
    
      
    
    //Librería que muestra los mensajes de error en el formulario
    @Inject
    private Messages messages;
    
    private LineaPedidoGridDataSource lineaPedidoGridDataSource;
    
    @Property
	private LineaPedido lineaPedido;
    
    
    public LineaPedidoGridDataSource getLineaPedidoGridDataSource() {
		return lineaPedidoGridDataSource;
	}
    
    public int getRowsPerPage() {
		return lineaPedidoGridDataSource.getAvailableRows();
	}
    
    
    
    void onActivate(Long pedidoId) {	
        if(pedidoId != null) {
            try {
                this.pedidoId = pedidoId;
                this.pedido = tiendaService.leerPedido(this.pedidoId);
                //System.out.println("xxxxxxxxxxxxxx"+this.pedido.getId()+"xxxxxxxxxxxxxxx");                
                this.numero = Integer.toString(this.pedido.getNumero());
                this.recepcionado = this.pedido.getRecepcionado();              
                tienda = this.pedido.getTienda();
                //System.out.println("xxxxxxxxxxxxxx"+tienda.getNombre()+"xxxxxxxxxxxxxxx");                        
                this.idTienda = Long.toString(this.tienda.getId()); 
                lineaPedidoGridDataSource = new LineaPedidoGridDataSource(tiendaService, pedidoId);
            } catch (Exception e) {
                 registrationForm.recordError("error-pedido");
            }
        }        
    }
    
    public Object [] getAConsultar() {
		return(new Object [] {this.pedidoId});
	}
    
   Object onPassivate() {
    return(new Object [] {pedidoId}); 
}


    void onValidateForm() {

        //Con esto tapestry comprueba que los datos que se vayan a enviar sean correctos.    
        if (!registrationForm.isValid()) {
            return;
        }
        
       
        try { 
            if(pedidoId!=null){
                this.pedido = tiendaService.leerPedido(pedidoId);
                this.pedido.setNumero(Integer.parseInt(numero));
                this.pedido.setRecepcionado(recepcionado);
                tienda = tiendaService.leerTienda(Long.parseLong(idTienda));
                this.pedido.setTienda(tienda);
                tiendaService.modificarPedido(pedido); 
            }
            else{
                Long idTiendaInt = Long.valueOf(idTienda);
                int numeroInt = Integer.parseInt(numero);

                tienda = tiendaService.leerTienda(idTiendaInt);
                 //Aplico el formato a la fecha actual
                fechaalta=sdf.parse(sdf.format(fechaalta));                  
                Pedido pedido = new Pedido(numeroInt,tienda,fechaalta,recepcionado);
                tiendaService.crearPedido(pedido);
            }                
            
        } catch (Exception e) {
            registrationForm.recordError( messages
                    .get("error-pedido"));
        }


    }

    Object onSuccess() {
        return Index.class;

    }

}
