package com.empresa.intranet.web.pages.tienda;

import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.OrigenGridDataSource;
import com.empresa.intranet.web.util.TiendaGridDataSource;
import com.empresa.intranet.web.util.UserSession;
import java.text.Format;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;
import org.apache.tapestry5.annotations.Component;

import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.corelib.components.TextField;
import org.apache.tapestry5.ioc.annotations.Inject;


@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class ListaOrigenes {
	private final static int ROWS_PER_PAGE = 2;

	@SessionState(create=false)
    private UserSession userSession;
	
	@Property
	private Origen origen;
	
	private OrigenGridDataSource origenGridDataSource;

	@Inject
	private Locale locale;

	@Inject
	private ServicioTienda tiendaService;
              
    
	public OrigenGridDataSource getOrigenGridDataSource() {
		return origenGridDataSource;
	}

	public Format getNumberFormat() {
		return NumberFormat.getInstance(locale);
	}

	public int getRowsPerPage() {
		return ROWS_PER_PAGE;
	}

	public Object [] getAConsultar() {
		return(new Object [] {origen.getId()});
	}
	
	void onActivate()
		throws ParseException {
		origenGridDataSource = new OrigenGridDataSource(
			tiendaService, ROWS_PER_PAGE);
	}

	Object[] onPassivate() {
		return new Object[] {};
	}

}
