package com.empresa.intranet.web.pages.tienda;

import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuarioDao;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.IncidenciaGridDataSource;
import com.empresa.intranet.web.util.PedidoGridDataSource;
import com.empresa.intranet.web.util.TiendaGridDataSource;
import com.empresa.intranet.web.util.UserSession;
import java.text.Format;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;
import javax.management.InstanceNotFoundException;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.InjectPage;

import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.corelib.components.TextField;
import org.apache.tapestry5.ioc.annotations.Inject;


@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class ListaPedidos {
	private final static int ROWS_PER_PAGE = 2;

	
	@Property
	private Pedido pedido;
	
	private PedidoGridDataSource pedidoGridDataSource;

	@Inject
	private Locale locale;
        
        @InjectPage
	private ListaPedidos listaPedidosPage;        

	@Inject
	private ServicioTienda tiendaService;
        
        private Long idTienda;
        
        //Filtros en funcion del perfil de usuario
        @SuppressWarnings("unused")
        @Property
        @SessionState(create=false)
        private UserSession userSession; 
        
        @Inject
        private ServicioUsuario serviciousuario;
                      
                      
              
	public PedidoGridDataSource getPedidoGridDataSource() {            
            //System.out.println("+++++++++++++++++++++"+userSession.getPerfilUsuarioId()+"+++++++++++++++++++");               
            return pedidoGridDataSource;              
	}

	public Format getNumberFormat() {
		return NumberFormat.getInstance(locale);
	}

	public int getRowsPerPage() {
		return ROWS_PER_PAGE;
	}

	public Object [] getAConsultar() {
		return(new Object [] {pedido.getId()});
	}
        
        public Long getIdTienda() {
            return idTienda;
        }

        public void setIdTienda(Long idTienda) {           
            this.idTienda = idTienda;
        }

        Object onSuccess() {
            listaPedidosPage.setIdTienda(idTienda);
            return(listaPedidosPage);
        }
        
                   
	void onActivate(Long idTienda)
		throws ParseException, InstanceNotFoundException {    
                Long idUsuario = userSession.getPerfilUsuarioId();                
                PerfilUsuario usuario = serviciousuario.leerUsuario(idUsuario);
                //Filtro por tienda para usuarios no administradores
                if (userSession.getEsAdmin() != true)
                    idTienda=usuario.getTienda().getId();
                
		pedidoGridDataSource = new PedidoGridDataSource(
			tiendaService, ROWS_PER_PAGE,idTienda);
	}

	Object[] onPassivate() {
		return new Object[] {idTienda};
	}
        
        Object onActionFromEliminar(long pedidoId) {
            Pedido pedido = tiendaService.leerPedido(pedidoId);            
            tiendaService.eliminarPedido(pedido);            
            return listaPedidosPage;
        }        

}
