package com.empresa.intranet.web.pages.usuario;

import com.empresa.intranet.modelo.roles.Rol;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.PerfilUsuarioDetalle;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.web.pages.Index;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.UserSession;
import javax.management.InstanceNotFoundException;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.ioc.annotations.Inject;


@AuthenticationPolicy(AuthenticationPolicyType.AUTHENTICATED_USERS)
public class ActualizaPerfil {

    @Property
    private String firstName;

    @Property
    private String lastName;

    @Property
    private String email;
    
    @Property
    private String idRol;    
    
    @Property
    private String idTienda;       

    @SessionState(create=false)
    private UserSession userSession;

    @Inject
    private ServicioUsuario userService;

    void onPrepareForRender() throws InstanceNotFoundException {

        PerfilUsuario perfilUsuario;

        perfilUsuario = userService.findPerfilUsuario(userSession
                .getPerfilUsuarioId());
        firstName = perfilUsuario.getFirstName();
        lastName = perfilUsuario.getLastName();
        email = perfilUsuario.getEmail();
        idRol=Long.toString(perfilUsuario.getRol().getId());
        idTienda=Long.toString(perfilUsuario.getTienda().getId());

    }

    Object onSuccess() throws InstanceNotFoundException {
        //FIXME: cambiar el rol (no poner 0) Cambiado
        Rol rol = userService.getRol(Long.parseLong(idRol));
        Tienda tienda = userService.getTienda(Long.parseLong(idTienda));
        userService.updatePerfilUsuarioDetails(
                
                userSession.getPerfilUsuarioId(), new PerfilUsuarioDetalle(
                        firstName, lastName, email,rol,tienda));
        userSession.setFirstName(firstName);
        return Index.class;

    }

}