package com.empresa.intranet.web.pages.usuario;

import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.web.services.AuthenticationPolicy;
import com.empresa.intranet.web.services.AuthenticationPolicyType;
import com.empresa.intranet.web.util.PerfilUsuarioGridDataSource;
import com.empresa.intranet.web.util.UserSession;
import java.text.Format;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;
import org.apache.tapestry5.annotations.InjectPage;

import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;
import org.apache.tapestry5.ioc.annotations.Inject;


@AuthenticationPolicy(AuthenticationPolicyType.ADMIN_USERS)

public class ListaPerfiles {
	private final static int ROWS_PER_PAGE = 2;

	@SessionState(create=false)
        private UserSession userSession;
	
	@Property
	private PerfilUsuario perfil;
	
	private PerfilUsuarioGridDataSource perfilusuarioGridDataSource;

	@Inject
	private Locale locale;

	@Inject
	private ServicioUsuario usuarioService;
              
        @InjectPage
        private ListaPerfiles listaPerfilesPage;
    
	public PerfilUsuarioGridDataSource getPerfilUsuarioGridDataSource() {
		return perfilusuarioGridDataSource;
	}

	public Format getNumberFormat() {
		return NumberFormat.getInstance(locale);
	}

	public int getRowsPerPage() {
		return ROWS_PER_PAGE;
	}

	public Object [] getAConsultar() {
		return(new Object [] {perfil.getPerfilUsuarioId()});
	}
        
        Object onActionFromEliminar(long perfilUsuarioId) {
            usuarioService.eliminarPerfilUsuario(perfilUsuarioId);
            return listaPerfilesPage;
        }
	
	void onActivate()
		throws ParseException {
		perfilusuarioGridDataSource = new PerfilUsuarioGridDataSource(
			usuarioService, ROWS_PER_PAGE);
	}

	Object[] onPassivate() {
		return new Object[] {};
	}

}
