package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.incidencias.Incidencia;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuarioDao;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.modelo.tiendas.Tienda;
import java.util.ArrayList;
import java.util.List;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class IncidenciaGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<Incidencia> incidencias = new ArrayList<Incidencia>();
	private int totalNumberOfIncidencias;
	private int startIndex;
        private Long idTienda;
	private boolean incidenciaNoExiste;
        private int rowsPerPage;
        private ServicioUsuario servicioUsuario;

	public IncidenciaGridDataSource(ServicioTienda servicioTienda, int rowsPerPage, Long idTienda) {

		this.servicioTienda = servicioTienda;
		this.rowsPerPage = rowsPerPage;
                this.idTienda = idTienda;                  
		try {
                    if(idTienda != null) {
			totalNumberOfIncidencias = servicioTienda.numeroIncidencias(idTienda);
                    } 
                    else {
                        totalNumberOfIncidencias = servicioTienda.numeroIncidencias();
                    }
		} catch (Exception e) {
			incidenciaNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfIncidencias;
    }

    @Override
    public Class<Incidencia> getRowType() {
        return Incidencia.class;
    }

    @Override
    public Object getRowValue(int index) {
        return incidencias.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
             if(idTienda != null){
                incidencias = servicioTienda.listaIncidencias(startIndex, rowsPerPage,idTienda);
            } 
            else {
                incidencias = servicioTienda.listaIncidencias(startIndex, rowsPerPage);
            }
            this.startIndex = startIndex;
	} catch (Exception e) {
          
        }
    }

}
