package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.lineaspedidos.LineaPedido;
import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class LineaPedidoGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<LineaPedido> lineas = new ArrayList<LineaPedido>();
	private int totalNumberOfLineas;
	private boolean pedidoNoExiste;
        private Long idPedido;

	public LineaPedidoGridDataSource(ServicioTienda servicioTienda, Long idPedido) {

		this.servicioTienda = servicioTienda;
		this.idPedido = idPedido;
		try {
			totalNumberOfLineas =
				servicioTienda.numeroLineasPedidos(idPedido);

		} catch (Exception e) {
			pedidoNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfLineas;
    }

    @Override
    public Class<LineaPedido> getRowType() {
        return LineaPedido.class;
    }

    @Override
    public Object getRowValue(int index) {
        return lineas.get(index);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
        	lineas = servicioTienda.listaLineasPedidos(idPedido);
		} catch (Exception e) {
                    int a = 0;
                }
    }

}
