package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.origenes.Origen;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class OrigenGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<Origen> tipo = new ArrayList<Origen>();
	private int totalNumberOfOrigenes;
	private int startIndex;
	private boolean usuarioNoExiste;
        private int rowsPerPage;

	public OrigenGridDataSource(ServicioTienda servicioTienda, int rowsPerPage) {

		this.servicioTienda = servicioTienda;
		this.rowsPerPage = rowsPerPage;
		try {
			totalNumberOfOrigenes =
				servicioTienda.numeroOrigenes();

		} catch (Exception e) {
			usuarioNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfOrigenes;
    }

    @Override
    public Class<Origen> getRowType() {
        return Origen.class;
    }

    @Override
    public Object getRowValue(int index) {
        return tipo.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
        	tipo = servicioTienda.listaOrigenes(startIndex, rowsPerPage);
	        this.startIndex = startIndex;
		} catch (Exception e) {}
    }

}
