package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuarioDao;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.tiendas.Tienda;
import java.util.ArrayList;
import java.util.List;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.annotations.SessionState;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class PedidoGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<Pedido> pedidos = new ArrayList<Pedido>();
	private int totalNumberOfPedidos;
	private int startIndex;
        private Long idTienda;
	private boolean pedidoNoExiste;
        private int rowsPerPage;

                

	public PedidoGridDataSource(ServicioTienda servicioTienda, int rowsPerPage,Long idTienda) {

		this.servicioTienda = servicioTienda;
		this.rowsPerPage = rowsPerPage;
                this.idTienda = idTienda;               
		try {
                    if(idTienda != null) {
                        totalNumberOfPedidos = servicioTienda.numeroPedidos(idTienda);
                    }
                    else{
			totalNumberOfPedidos =
				servicioTienda.numeroPedidos();
                    }

		} catch (Exception e) {
			pedidoNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfPedidos;
    }

    @Override
    public Class<Pedido> getRowType() {
        return Pedido.class;
    }

    @Override
    public Object getRowValue(int index) {
        return pedidos.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
                if(idTienda != null) {
                    pedidos = servicioTienda.listaPedidos(startIndex, rowsPerPage,idTienda);    
                }
                else{
                    pedidos = servicioTienda.listaPedidos(startIndex, rowsPerPage);   
                }        	
	        this.startIndex = startIndex;
		} catch (Exception e) {

                
                }
    }

}
