package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.modelo.tiendas.Tienda;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class PerfilUsuarioGridDataSource implements GridDataSource {

	private ServicioUsuario servicioUsuario;
	private List<PerfilUsuario> perfil = new ArrayList<PerfilUsuario>();
	private int totalNumberOfPerfiles;
	private int startIndex;
	private boolean perfilNoExiste;
        private int rowsPerPage;

	public PerfilUsuarioGridDataSource(ServicioUsuario servicioUsuario, int rowsPerPage) {

		this.servicioUsuario = servicioUsuario;
		this.rowsPerPage = rowsPerPage;
		try {
			totalNumberOfPerfiles =
				servicioUsuario.numeroPerfiles();

		} catch (Exception e) {
			perfilNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfPerfiles;
    }

    @Override
    public Class<PerfilUsuario> getRowType() {
        return PerfilUsuario.class;
    }

    @Override
    public Object getRowValue(int index) {
        return perfil.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
        	perfil = servicioUsuario.listaPerfiles(startIndex, rowsPerPage);
	        this.startIndex = startIndex;
		} catch (Exception e) {
                    int a = 0;
                }
    }

}
