package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.tiendas.Tienda;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class TiendaGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<Tienda> tiendas = new ArrayList<Tienda>();
	private int totalNumberOfTiendas;
	private int startIndex;
	private boolean usuarioNoExiste;
        private int rowsPerPage;

	public TiendaGridDataSource(ServicioTienda servicioTienda, int rowsPerPage) {

		this.servicioTienda = servicioTienda;
		this.rowsPerPage = rowsPerPage;
		try {
			totalNumberOfTiendas =
				servicioTienda.numeroTiendas();

		} catch (Exception e) {
			usuarioNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfTiendas;
    }

    @Override
    public Class<Tienda> getRowType() {
        return Tienda.class;
    }

    @Override
    public Object getRowValue(int index) {
        return tiendas.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
        	tiendas = servicioTienda.listaTiendas(startIndex, rowsPerPage);
	        this.startIndex = startIndex;
		} catch (Exception e) {}
    }

}
