package com.empresa.intranet.web.util;

import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.tipos.Tipo;
import java.util.ArrayList;
import java.util.List;

import org.apache.tapestry5.grid.GridDataSource;
import org.apache.tapestry5.grid.SortConstraint;


public class TipoGridDataSource implements GridDataSource {

	private ServicioTienda servicioTienda;
	private List<Tipo> tipo = new ArrayList<Tipo>();
	private int totalNumberOfTipos;
	private int startIndex;
	private boolean usuarioNoExiste;
        private int rowsPerPage;

	public TipoGridDataSource(ServicioTienda servicioTienda, int rowsPerPage) {

		this.servicioTienda = servicioTienda;
		this.rowsPerPage = rowsPerPage;
		try {
			totalNumberOfTipos =
				servicioTienda.numeroTipos();

		} catch (Exception e) {
			usuarioNoExiste = true;
		}

	}

    @Override
    public int getAvailableRows() {
        return totalNumberOfTipos;
    }

    @Override
    public Class<Tipo> getRowType() {
        return Tipo.class;
    }

    @Override
    public Object getRowValue(int index) {
        return tipo.get(index-this.startIndex);
    }

    @Override
    public void prepare(int startIndex, int endIndex,
    	List<SortConstraint> sortConstraints) {
        try {
        	tipo = servicioTienda.listaTipos(startIndex, rowsPerPage);
	        this.startIndex = startIndex;
		} catch (Exception e) {}
    }

}
