-- ----------------------------------------------------------------------------
-- "MiniPortal" example.
-------------------------------------------------------------------------------

-- Indexes for primary keys have been explicitly created.

-- ------------------------------ PerfilUsuario ----------------------------------

DROP TABLE PerfilUsuario;
DROP TABLE Rol;
DROP TABLE Incidencia;
DROP TABLE Origen;
DROP TABLE Tipo;
DROP TABLE LineaPedido;
DROP TABLE Pedido;
DROP TABLE Tienda;


CREATE TABLE Rol(
	id bigInt NOT NULL AUTO_INCREMENT,
	descripcion VARCHAR(50) COLLATE latin1_bin NULL,
        CONSTRAINT PK_Rol PRIMARY KEY (id)) ENGINE = InnoDB;

INSERT INTO Rol(descripcion) VALUES ('central');
INSERT INTO Rol(descripcion) VALUES ('tienda');

CREATE TABLE Tienda(
	id bigInt NOT NULL AUTO_INCREMENT,
	nombre VARCHAR(50) COLLATE latin1_bin NOT NULL,
 CONSTRAINT PK_Tienda PRIMARY KEY (id)) ENGINE = InnoDB;

insert into tienda (nombre) values('Coruña')

CREATE TABLE PerfilUsuario(
	usrId bigint NOT NULL AUTO_INCREMENT,
	loginName varchar(30) COLLATE latin1_bin NOT NULL,
	enPassword varchar(50) COLLATE latin1_bin NOT NULL,
	firstName varchar(30) COLLATE latin1_bin NOT NULL,
	lastName varchar(40) COLLATE latin1_bin NOT NULL,
	email varchar(60) COLLATE latin1_bin NOT NULL,	
	idRol bigInt NOT NULL,
	idTienda bigInt NOT NULL,
 CONSTRAINT FK_tienda FOREIGN KEY(idTienda REFERENCES Tienda (id),
 CONSTRAINT FK_rol FOREIGN KEY(idRol) REFERENCES Rol (id),
 CONSTRAINT PK_PerfilUsuario PRIMARY KEY(usrId),
 CONSTRAINT LoginNameUniqueKey UNIQUE (loginName)) ENGINE = InnoDB;


CREATE TABLE Tipo(
	id int NOT NULL AUTO_INCREMENT,
	nombre VARCHAR(50) COLLATE latin1_bin NOT NULL,
 CONSTRAINT PK_Tipo PRIMARY KEY (id)) ENGINE = InnoDB;

CREATE TABLE Origen(
	id int NOT NULL AUTO_INCREMENT,
	nombre VARCHAR(50) COLLATE latin1_bin NOT NULL,
	idTipo int NOT NULL,
 CONSTRAINT PK_Origen PRIMARY KEY (id )) ENGINE = InnoDB;

ALTER TABLE Origen ADD  CONSTRAINT FK_Origen_Tipo FOREIGN KEY(idTipo)
REFERENCES Tipo (id);


CREATE TABLE Incidencia(
	id int NOT NULL AUTO_INCREMENT,
	numero int NOT NULL,
	idTienda bigint NOT NULL,
	fechaalta datetime NOT NULL,
	detectadapor VARCHAR(50) COLLATE latin1_bin NOT NULL,
	recepcionada smallint NULL,
	numeroalbaran VARCHAR(50) COLLATE latin1_bin NOT NULL,
	numerolinea int NOT NULL,
	descripcion VARCHAR(250) COLLATE latin1_bin NOT NULL,
	idOrigen int NOT NULL,
	idTipo int NOT NULL,
 CONSTRAINT PK_Incidencia PRIMARY KEY (id ASC)) ENGINE = InnoDB;

ALTER TABLE Incidencia ADD  CONSTRAINT fk_incidencias_origenes FOREIGN KEY(idOrigen)
REFERENCES Origen (id);
ALTER TABLE Incidencia  ADD  CONSTRAINT FK_Incidencia_Tienda FOREIGN KEY(idTienda)
REFERENCES Tienda (id);
ALTER TABLE Incidencia ADD  CONSTRAINT fk_incidencias_tipos FOREIGN KEY(idTipo)
REFERENCES Tipo (id);

CREATE TABLE Pedido(
	id bigint NOT NULL,
	numero int NOT NULL,
	idTienda bigint NOT NULL,
	fechaalta datetime NOT NULL,
	recepcionado smallint NULL,
 CONSTRAINT PK_Pedido PRIMARY KEY 
(id
)
) ENGINE = InnoDB;

ALTER TABLE Pedido  ADD  CONSTRAINT FK_Pedido_Tiendas FOREIGN KEY(idTienda)
REFERENCES Tienda (id);

CREATE TABLE LineaPedido(
	id bigint NOT NULL,
	numeroLinea int NOT NULL,
	codigo VARCHAR(15) COLLATE latin1_bin NOT NULL,
	descripción VARCHAR(100) COLLATE latin1_bin NULL,
	cantidad int NULL,
	precio float NULL,
	importe float NULL,
	idPedido bigint NOT NULL,
 CONSTRAINT PK__LinneasPedido__164452B1 PRIMARY KEY 
(
	id
)
) ENGINE = InnoDB;

ALTER TABLE LineaPedido ADD  CONSTRAINT fk_linpedido_pedido FOREIGN KEY(idPedido)
REFERENCES Pedido (id);







/*!40000 ALTER TABLE `PerfilUsuario` DISABLE KEYS */;
INSERT INTO `PerfilUsuario` VALUES (1,'a','OI9GAobMN74N4y0cnsKtqkeDrOKBQh7k80Vlpu3dY5Q=','a','a','a@a.com',1);
INSERT INTO `PerfilUsuario` VALUES (2,'b','OI9GAobMN74N4y0cnsKtqkeDrOKBQh7k80Vlpu3dY5Q=','b','b','a@a.com',2);
/*!40000 ALTER TABLE `PerfilUsuario` ENABLE KEYS */;

/*!40000 ALTER TABLE `Tienda` DISABLE KEYS */;
INSERT INTO `Tienda` VALUES (1,'fadsdsf');
/*!40000 ALTER TABLE `Tienda` ENABLE KEYS */;