package com.empresa.intranet.test.modelo.serviciousuario;

import com.empresa.intranet.modelo.incidencias.Incidencia;
import com.empresa.intranet.modelo.origenes.Origen;
import com.empresa.intranet.modelo.pedidos.Pedido;
import com.empresa.intranet.modelo.roles.Rol;
import com.empresa.intranet.modelo.serviciotienda.ServicioTienda;
import com.empresa.intranet.modelo.perfilusuario.PerfilUsuario;
import com.empresa.intranet.modelo.serviciousuario.ServicioUsuario;
import com.empresa.intranet.modelo.serviciousuario.PerfilUsuarioDetalle;
import com.empresa.intranet.modelo.tiendas.Tienda;
import com.empresa.intranet.modelo.tipos.Tipo;
import com.empresa.intranet.modelo.util.DuplicatedInstanceException;
import static com.empresa.intranet.modelo.util.GlobalNames.SPRING_CONFIG_FILE;
import static com.empresa.intranet.test.util.GlobalNames.SPRING_CONFIG_TEST_FILE;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.management.InstanceNotFoundException;
import javax.swing.JOptionPane;

import org.junit.Test;
import org.junit.runner.RunWith;
import static org.junit.Assert.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.transaction.annotation.Transactional;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = { SPRING_CONFIG_FILE, SPRING_CONFIG_TEST_FILE})
@Transactional
public class ServicioUsuarioTest {

    private final long NON_EXISTENT_USER_PROFILE_ID = -1;

    @Autowired
    ServicioUsuario userService;
    
    @Autowired
    ServicioTienda tiendaService;
    
    
    @Test
    public void testTonto() throws DuplicatedInstanceException, InstanceNotFoundException{
        //Tienda t = tiendaService.registrarTienda("hola");
//        Tienda t = new Tienda("lugo");
//        Tienda t2 = tiendaService.crearTienda(t);

        
        Rol rol = userService.registerRol(new Rol("admin"));
        Tienda tienda = new Tienda("Coruña");
        Tienda tienda2 = tiendaService.crearTienda(tienda);
        PerfilUsuarioDetalle perfilUsuarioDetails = new PerfilUsuarioDetalle(
            "name", "lastName", "ibecerra@gmail.com", rol,tienda);
        PerfilUsuario perfilUsuario = userService.registerUser("user", "userPassword", perfilUsuarioDetails);
        System.out.println(perfilUsuario.getEncryptedPassword());
        PerfilUsuario perfilUsuario2 = userService.findPerfilUsuario(
        perfilUsuario.getPerfilUsuarioId());

        Rol rol1 = userService.getRol((long)1);
        assertEquals("central", rol1.getDescripcion());

    }

     @Test
    public void testTonto2() throws DuplicatedInstanceException, InstanceNotFoundException{ 
//         Tipo tipo = new Tipo("tipo 1");
//         Tipo tipo2 = tiendaService.crearTipo(tipo);
//         Tipo tipo1 = tiendaService.leerTipo(1L);
//         Origen origen = new Origen("Origen", tipo1);
//         Origen origen2 = tiendaService.crearOrigen(origen);
//         assertEquals(origen.getNombre(), origen2.getNombre());
    }
    
    @Test
    public void testIncidencias() throws DuplicatedInstanceException, InstanceNotFoundException{ 
         //Incidencia(numeroInt,tienda,fechaalta,detectadapor,recepcionada,numeroalbaran,numerolineaInt,descripcion,origen,tipo);
        SimpleDateFormat sdf=new java.text.SimpleDateFormat("dd/MM/yyyy");
        Date fechaactual = new java.util.Date();
            //Aplico el formato a la fecha actual
            try {
                fechaactual=sdf.parse(sdf.format(fechaactual));
            } catch (Exception ex) {
               JOptionPane.showMessageDialog(null,"Error","Error", JOptionPane.ERROR_MESSAGE);
            }        
            
         Tipo tipo = new Tipo("tipo 1");
         Tipo tipo1 = tiendaService.crearTipo(tipo);         
         Origen origen = new Origen("Origen", tipo1);
         Origen origen1 = tiendaService.crearOrigen(origen);
         Tienda tienda = new Tienda("Coruña");
         Tienda tienda1=tiendaService.crearTienda(tienda);
         Incidencia incidencia= new Incidencia(1,tienda,fechaactual,"Ivan",1,"1234",10,"Incidencia de prueba",origen,tipo);         
         Incidencia incidencia1=tiendaService.crearIncidencia(incidencia);
         Incidencia incidencia2=tiendaService.leerIncidencia(1L);
         System.out.println("++++++++++++++++++++ "+incidencia2.getDescripcion()+" ++++++++++++++++++++"); 
         assertEquals(incidencia.getDescripcion(), incidencia2.getDescripcion());
         
         
    }
    @Test
    public void testPedidos() throws DuplicatedInstanceException, InstanceNotFoundException{ 
         //Incidencia(numeroInt,tienda,fechaalta,detectadapor,recepcionada,numeroalbaran,numerolineaInt,descripcion,origen,tipo);
        SimpleDateFormat sdf=new java.text.SimpleDateFormat("dd/MM/yyyy");
        Date fechaactual = new java.util.Date();
            //Aplico el formato a la fecha actual
            try {
                fechaactual=sdf.parse(sdf.format(fechaactual));
            } catch (Exception ex) {
               JOptionPane.showMessageDialog(null,"Error","Error", JOptionPane.ERROR_MESSAGE);
            }        
            
         Tienda tienda=tiendaService.leerTienda(1L);
         Pedido pedido = new Pedido(1,tienda,fechaactual,0);
         Pedido pedido1=tiendaService.crearPedido(pedido);
         Pedido pedido2=tiendaService.leerPedido(1L);
         System.out.println("++++++++++++++++++++ "+pedido.getNumero()+" ++++++++++++++++++++"); 
         assertEquals(pedido.getNumero(), pedido1.getNumero());
    }

}
